//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_color3     PaleVioletRed
#property indicator_color4     DeepSkyBlue
#property indicator_width1     3
#property indicator_width2     3
#property indicator_width3     2
#property indicator_width4     2
#property indicator_levelstyle STYLE_DASHDOTDOT
#property indicator_levelcolor Gold

//
//
//
//
//

extern string TimeFrame          = "Current time frame";
extern int    BullBearPrice      = 0;
extern double BullBearPeriod     = 13;
extern double T3Period           = 5;
extern double T3Hot              = 1.0; 
extern bool   T3Original         = false; 
extern double tradeLevel         = 0.0005;

extern bool   arrowsVisible      = true;
extern bool   arrowsOnSlope      = true;
extern string arrowsIdentifier   = "bullsbears arrows1";
extern double arrowsDisplacement = 1.0;
extern color  arrowsUpColor      = LimeGreen;
extern color  arrowsDnColor      = Red;
extern int    arrowsUpCode       = 159;
extern int    arrowsDnCode       = 159;
extern int    arrowsUpWidth      = 2;
extern int    arrowsDnWidth      = 2;

//
//
//
//
//

double acUp[];
double acDn[];
double bears[];
double bulls[];
double Buf3[];
double Buf4[];
double ac[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
  {
   IndicatorBuffers(8);   
   SetIndexBuffer(0,acUp);SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,acDn);SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,bears);
   SetIndexBuffer(3,bulls);
   SetIndexBuffer(4,Buf3);
   SetIndexBuffer(5,Buf4);
   SetIndexBuffer(6,ac);
   SetIndexBuffer(7,trend);
   SetLevelValue(0,0);
   SetLevelValue(1,tradeLevel);
   
      //
      //
      //
      //
      //
     
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
     
     //
     //
     //
     //
     //
   
     IndicatorShortName(timeFrameToString(timeFrame)+"   Bulls Bears Ac ("+DoubleToStr(BullBearPeriod,2)+","+DoubleToStr(T3Period,2)+")");
return(0);
}

//
//
//
//
//

int deinit()
{
     
    if (!calculateValue && arrowsVisible) deleteArrows();
      
return(0); 
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { acUp[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
   
     for (i=limit; i>=0; i--) Buf3[i] = iMA(NULL,0,5,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,34,0,MODE_SMA,PRICE_MEDIAN,i);
     for (i=limit; i>=0; i--)
     {
     
        Buf4[i] = iMAOnArray(Buf3,Bars,5,0,MODE_SMA,i);
        ac[i]   = Buf3[i] - Buf4[i]; 
        acUp[i] = EMPTY_VALUE;
        acDn[i] = EMPTY_VALUE;
   
   
        if (ac[i]  > ac[i+1]) 
             acUp[i] = ac[i]; 
        else acDn[i] = ac[i];
        double price = iMA(NULL,0,BullBearPeriod,0,MODE_SMA,BullBearPrice,i);
        bears[i]     = iT3(price-Low[i], T3Period,T3Hot,T3Original,i,0);
        bulls[i]     = iT3(High[i]-price,T3Period,T3Hot,T3Original,i,1);
        trend[i] = trend[i+1];
           if (bulls[i] > bears[i] && bulls[i] > tradeLevel) trend[i] = 1;
           if (bulls[i] < bears[i] && bears[i] > tradeLevel) trend[i] =-1;
           manageArrow(i);
     }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {   
      int y = iBarShift(NULL,timeFrame,Time[i]);
         acUp[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullBearPrice,BullBearPeriod,T3Period,T3Hot,T3Original,tradeLevel,0,y);
         acDn[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullBearPrice,BullBearPeriod,T3Period,T3Hot,T3Original,tradeLevel,1,y);
         bears[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullBearPrice,BullBearPeriod,T3Period,T3Hot,T3Original,tradeLevel,2,y);
         bulls[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullBearPrice,BullBearPeriod,T3Period,T3Hot,T3Original,tradeLevel,3,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BullBearPrice,BullBearPeriod,T3Period,T3Hot,T3Original,tradeLevel,7,y);
         manageArrow(i);
         
    }
return(0);
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][12];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (trend[i] != trend[i+1])
      {
        if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,arrowsUpWidth,false);
        if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode,arrowsDnWidth, true);
      }         
      
    }                  
}       

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theWidth, bool up)
{
    string name = arrowsIdentifier+":"+Time[i];
    double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

